function entry(Source, Input){

InputStack = Input // This is the "left stack", also known as the "stack not on the Right". Input goes here.
kcatStupnI = []; // This is the "right stack", also known as the "stack on the Right". The evil twin of the input stack.
Active = 1.0; // Left stack Active: 1 is at the Left of the decimal point.


FormattedSource = Source.replace(/(\[\]|\(\)|{\}|\<>)/g, nilad => ({"()":"○","[]":"⎕","{}":"⍬","<>":"♢"}[nilad]));
// APL symbols look good and Brain-Flak was simpler to implement this way to me.
console.log(FormattedSource); // Bask in the glory of APL symbols.

function run(Snippet) {
	let Pointer = 0
	let EValue = []; // Short for "evaluated value".

	while (Pointer * Pointer != Math.pow(Snippet.length,2)) { // Are we done with the snippet?

		switch (Snippet[Pointer]) {
			case "○":
				EValue.push(1);
				break//
			case "⎕":
				EValue.push((Active==1.0?InputStack:kcatStupnI).length);
				break//
			case "⍬":
				popped = (Active==1.0?InputStack:kcatStupnI).pop();
				EValue.push(typeof popped == "undefined" ? 0 : popped); // According to the specification,
				// Brain-Flak should return 0 if the active stack is empty.
				break//
			case "♢":
				Active = (Active == 1.0 ? 0.1 : 1.0) // Toggles which stack is active.
				EValue.push(0);
				break//

			case "(": {
				let NestingLevel = 1
				let EnclosedSnippet = ""
				while (NestingLevel != 0) {
					Pointer = Pointer + (Pointer?Pointer / Pointer:1)
					EnclosedSnippet += Snippet[Pointer]
					if (Snippet[Pointer] == "(") {NestingLevel += 1} else if
					(Snippet[Pointer] == ")") {NestingLevel -= 1}
				}

				EnclosedSnippet = EnclosedSnippet.substring(0, EnclosedSnippet.length - 1);
				result = run(EnclosedSnippet);
				EValue.push(result);
				(Active==1.0?InputStack:kcatStupnI).push(result);
			}
			;break//
			
			case "<": {
				let NestingLevel = 1
				let EnclosedSnippet = ""
				while (NestingLevel != 0) {
					Pointer = Pointer + (Pointer?Pointer / Pointer:1)
					EnclosedSnippet += Snippet[Pointer]
					if (Snippet[Pointer] == "<") {NestingLevel += 1} else if
					(Snippet[Pointer] == ">") {NestingLevel -= 1}
				}

				EnclosedSnippet = EnclosedSnippet.substring(0, EnclosedSnippet.length - 1);
				run(EnclosedSnippet)
				EValue.push(0)
			}
			;break//
	
			case "{": {
				let NestingLevel = 1
				let EnclosedSnippet = ""
				while (NestingLevel != 0) {
					Pointer = Pointer + (Pointer?Pointer / Pointer:1)
					EnclosedSnippet += Snippet[Pointer]
					if (Snippet[Pointer] == "{") {NestingLevel += 1} else if
					(Snippet[Pointer] == "}") {NestingLevel -= 1}
				}

				EnclosedSnippet = EnclosedSnippet.substring(0, EnclosedSnippet.length - 1);
				let EValueInCurlyBraces = []
				while ((Active==1.0?InputStack:kcatStupnI)[(Active==1.0?InputStack:kcatStupnI).length-1] != 0
				       || (Active==1.0?InputStack:kcatStupnI).length == 0) {
					EValueInCurlyBraces.push(run(EnclosedSnippet))
				}
				EValue.push( EValueInCurlyBraces.reduce((x, y) => x+y, 0))
			
			}
			;break//

			case "[": {
				let NestingLevel = 1
				let EnclosedSnippet = ""
				while (NestingLevel != 0) {
					Pointer = Pointer + (Pointer?Pointer / Pointer:1)
					EnclosedSnippet += Snippet[Pointer]
					if (Snippet[Pointer] == "[") {NestingLevel += 1} else if
					(Snippet[Pointer] == "]") {NestingLevel -= 1}
				}

				EnclosedSnippet = EnclosedSnippet.substring(0, EnclosedSnippet.length - 1);
				EValue.push(0 - run(EnclosedSnippet))
			}
			;break//
		}
	
		Pointer = Pointer + (Pointer?Pointer / Pointer:1) // There is probably no better way to increment a variable.
	}
	let evalue_final_FINAL_jpg = EValue.reduce((x, y) => x+y, 0)
	return evalue_final_FINAL_jpg;
}

run(FormattedSource)
console.log(Active==1.0?InputStack:kcatStupnI) // Shows the active stack.
return (Active==1.0?InputStack:kcatStupnI)
}

/*
// Example program from the Esolangs wiki.
// This program computes [number on the stack not on the Right] steps of the Fibonacci sequence.
entry("<>((()))<>{({}[()])<>({}<>)<>(({})<>({}<>))<>}<>{}{}", [50]);
*/